<?

 /*************************************************************************************
 * Filename: ut/skeleton.php
 *
 * This file is part of the skeleton JAS plugin.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The skeleton JAS plugin is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/skeleton/
 *************************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");

 class UT_Plugin_Skeleton extends UT_Plugins
 {
  function Constructor()
  {
   $p=new Plugin("skeleton");
   $p->initClass("frontend");

   if(!is_object($p->class["frontend"]["object"])||get_class($p->class["frontend"]["object"])!="Plugin_skeleton")
   {
    $this->e->add("Class isn't a Plugin_skeleton object", "error");
    return UT_FAILED;
   }

   if(get_parent_class($p->class["frontend"]["object"])!="Base_Plugin")
   {
    $this->e->add("Class isn't a Base_Plugin object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Main()
  {
   $p=new Plugin("skeleton");
   $p->initClass("frontend");

   if($p->call("frontend", "main")!==true)
   {
    $this->e->add("Plugin main function should return true", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   $p->e->add("test", "error");
   if($p->call("frontend", "main")!==false)
   {
    $this->e->add("Plugin main function should return false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Output()
  {
   $p=new Plugin("skeleton");
   $p->initClass("frontend");

   if($p->call("frontend", "output")===false)
   {
    $this->e->add("Plugin output function shouldn't return false", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   $p->e->add("test", "error");
   if($p->call("frontend", "output")!==false)
   {
    $this->e->add("Plugin output function should return false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }
 }


 class UT_Plugin_Skeleton_Backend extends UT_Plugin_Skeleton
 {
  function Constructor()
  {
   $p=new Plugin("skeleton");
   $p->initClass("backend");

   if(!is_object($p->class["backend"]["object"])||get_class($p->class["backend"]["object"])!="Plugin_Backend_skeleton")
   {
    $this->e->add("Class isn't a Plugin_Backend_skeleton object", "error");
    return UT_FAILED;
   }

   if(get_parent_class($p->class["backend"]["object"])!="Base_Plugin_Backend")
   {
    $this->e->add("Class isn't a Base_Plugin_Backend object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Main()
  {
   $p=new Plugin("skeleton");
   $p->initClass("backend");

   if($p->call("backend", "main")!==true)
   {
    $this->e->add("Plugin backend main function should return true", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   $p->e->add("test", "error");
   if($p->call("backend", "main")!==false)
   {
    $this->e->add("Plugin backend main function should return false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Output()
  {
   $p=new Plugin("skeleton");
   $p->initClass("backend");

   if($p->call("backend", "output", "main")===false)
   {
    $this->e->add("Plugin backend output function shouldn't return false", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   $p->e->add("test", "error");
   if($p->call("backend", "output", "main")!==false)
   {
    $this->e->add("Plugin backend output function should return false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }
 }

 class UT_Plugin_Skeleton_Setup extends UT_Plugin_Skeleton
 {
  function Constructor()
  {
   $p=new Plugin("skeleton");
   $p->initClass("setup");

   if(!is_object($p->class["setup"]["object"])||get_class($p->class["setup"]["object"])!="Plugin_Setup_skeleton")
   {
    $this->e->add("Class isn't a Plugin_Setup_skeleton object", "error");
    return UT_FAILED;
   }

   if(get_parent_class($p->class["setup"]["object"])!="Base_Plugin_Setup")
   {
    $this->e->add("Class isn't a Base_Plugin_setup object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Init()
  {
   $p=new Plugin("skeleton");
   $p->initClass("setup");

   if($p->call("setup", "init")!==true)
   {
    $this->e->add("Plugin setup init function should return true", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   return UT_OK;
  }
 }

?>
